config/routes.rb
Rails.application.routes.draw do
  resources :lottery_topics
  resources :posts
  resource :users,
    only: [:edit, :update, :delete],
    controller: 'devise/registrations',
    as: :user_registration do
    get 'cancel'
  end

  devise_for :users, skip: [:registrations]
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root "home#index"
  resources :users do
    resource :reset_passwords
  end
  resources :admins
  resources :admins,
    only: [:edit, :update, :delete],
    controller: 'devise/registrations',
    as: :admin_registration do
    get 'cancel'
  end
  resources :agents do 
    resources :member_invoices do
      resources :members do
        get '/confirmed', to: 'member_invoices#confirmed'
      end
    end
  end
  resources :members
  resources :profiles do
    resource :passwords
  end
  resources :lotteries
  resources :bills do
    resources :lotteries
    get '/confirmed', to: 'bills#confirmed'
  end

  resources :invoices

  get 'rood', to: 'lotteries#rood'
  get 'reverse', to: 'lotteries#reverse'
  get 'all_reverse', to: 'lotteries#all_reverse'
  get 'run', to: 'lotteries#run'
  get 'destroy_group', to: 'lotteries#destroy_group'

  get '/create_lottery', to: 'home#owner_lottery'
end

app/models/member.rb
class Member < TableLess
  column :name, :string
  column :email, :string
  column :password, :string
  column :password_confirmation, :string
  column :role, :string
  column :parent_id, :string
end

app/controllers/members_controller.rb
class MembersController < ApplicationController

  # before_action :authenticate_user_role!

  def index
    if current_user.super_admin?
      @members = User.where(role: 'member')
    else
      @members = User.where(parent_id: current_user.id, role: 'member')
    end
  end

  def edit
    
  end

  def new
    @member = User.new
    @user_datum = @member.build_user_datum
  end

  def create
    @user = User.new(member_params)
    @user.role = 'member'
    @user.parent_id = current_user.id
    respond_to do |format|
      if @user.save
        # User.create_user_datum(@user, params)
        format.html { redirect_to members_url, notice: "เพิ่ม Member แล้ว" }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  private
    def set_member
      @user = User.find(params[:id])
    end

    def member_params
      params.require(:member).permit(:email, :name, :role, :password, :password_confirmation, :username)
    end

    def authenticate_user_role!
      unless current_user.avalability_member?
        redirect_to root_path
      end
    end

end

app/helpers/members_helper.rb
module MembersHelper
end

app/views/members/_form.html.erb
<%= form_with(model: member) do |form| %>

  <div class="form-group">
    <%= form.label :ชื่อ, style: "display: block" %>
    <%= form.text_field :name, class: 'form-control' %>
    <% member.errors.full_messages_for(:name).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("name","") %>
      </div>
    <% end %>

    <%= form.label :username, style: "display: block" %>
    <%= form.text_field :username, class: 'form-control' %>
    <% member.errors.full_messages_for(:username).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("username","") %>
      </div>
    <% end %>

    <%= form.label :email, style: "display: block" %>
    <%= form.text_field :email, class: 'form-control' %>
    <% member.errors.full_messages_for(:email).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("email","") %>
      </div>
    <% end %>

    <%= form.fields_for @user_datum do |datum| %>

    
      <%= datum.label 'สองตัว/บาทละ', style: "display: block" %>
      <%= datum.text_field :percent, class: 'form-control' %>
      <% member.errors.full_messages_for(:percent).each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("percent","") %>
        </div>
      <% end %>

      <%= datum.label 'สามตัวตรง/บาทละ', style: "display: block" %>
      <%= datum.text_field :three_percent, class: 'form-control' %>
      <% member.errors.full_messages_for(:three_percent).each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("three_percent","") %>
        </div>
      <% end %>

      <%= datum.label 'สามตัวโต๊ด/บาทละ', style: "display: block" %>
      <%= datum.text_field :three_reverse_percent, class: 'form-control' %>
      <% member.errors.full_messages_for(:three_reverse_percent).each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("three_reverse_percent","") %>
        </div>
      <% end %>

      <%= datum.label 'วิ่ง/บาทละ', style: "display: block" %>
      <%= datum.text_field :run_percent, class: 'form-control' %>
      <% member.errors.full_messages_for(:run_percent).each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("run_percent","") %>
        </div>
      <% end %>

      <%= datum.label :เปอร์เซ็น, style: "display: block" %>
      <%= datum.text_field :user_percent, class: 'form-control' %>
      <% member.errors.full_messages_for(:percent_user).each do |error_message| %>
        <div class="text-red">
          <%= error_message.sub("percent","") %>
        </div>
      <% end %>

    <% end %>

    <%= form.label :รหัสผ่าน, style: "display: block" %>
    <%= form.password_field :password, class: 'form-control' %>
    <% member.errors.full_messages_for(:password).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("password","") %>
      </div>
    <% end %>

    <%= form.label :ยืนยันรหัสผ่าน, style: "display: block" %>
    <%= form.password_field :password_confirmation, class: 'form-control' %>
    <% member.errors.full_messages_for(:password_confirmation).each do |error_message| %>
      <div class="text-red">
        <%= error_message.sub("password_confirmation","") %>
      </div>
    <% end %>
  </div>



  <div>
    <%= form.submit 'บันทึก', class: 'btn btn-primary' %>
  </div>
<% end %>

app/views/members/edit.html.erb
<div class="container">
  <h1>แก้ไขผู้ใช้งาน</h1>

  <%= render "form", user: @user %>

  <br>

  <div class="pull-right">
    <%= link_to "กลับ", user_path(@user), class: 'btn btn-success' %>
  </div>
</div>

app/views/members/index.html.erb
<div class="container">
  <h2>Member</h2>
  <div class="pull-right">
    <%= link_to "เพิ่ม", new_user_path, class: 'btn btn-primary' %>
  </div>      
  <table class="table">
    <thead>
      <tr>
        <th>ชื่อ</th>
        <th>username</th>
        <th>role</th>
        <th>บาทละ</th>
        <th>เปอเซ็นต์</th>
        <th></th>
      </tr>
    </thead>
    <tbody>
      <% @members.each do |member| %>
      <tr>
        <td><%= member.name %></td>
        <td><%= member.username %></td>
        <td><%= member.role %></td>
        <td><%= member.user_datum.try(:percent) %></td>
        <td><%= member.user_datum.try(:user_percent) %></td>
        <td></td>
        <td class="manage">
          <%= link_to "ดู", user_path(member), class: 'btn btn-warning' %>
          <%= link_to "แก้ไข", edit_user_path(member), class: 'btn btn-success' %>
          <%= button_to "ลบ", member, method: :delete, class: 'btn btn-danger', data: { confirm: 'ยืนยันว่าจะลบ Member นี้' } %>
        </td>
      </tr>
      <% end %>
    </tbody>
  </table>
</div>

app/views/members/new.html.erb
<div class="container">
  <h1>เพิ่ม Member</h1>

  <%= render "form", member: @member, member_datum: @user_datum %>

  <br>

  <div class="pull-right">
    <%= link_to "กลับ", members_path, class: 'btn btn-success' %>
  </div>
</div>